#include <bits/stdc++.h>
#define endl '\n'
#define int long long

using namespace std;

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,q;
    cin>>n>>q;
    vector<pair<int,int>> v (n+1);
    v[0].first=0;
    v[0].second=0;
    for(int i=1;i<=n;i++)cin>>v[i].first>>v[i].second;
    for(int i=0;i<n;i++){
        int k=(v[i+1].first-v[i].first);
        if(v[i].second>k){
            int r=v[i].second-k;
            v[i].second=k;
            v[i+1].second+=r;
        }
    }

    int pos=0;
    int sum=0;

    for(int i=0;i<q;i++){
        int x;
        cin>>x;
        while(pos<n && v[pos+1].first<x){
            pos++;
            sum+=v[pos].second;
        }
        cout<<sum-v[pos].second+min(v[pos].second,x-v[pos].first+1)<<endl;
    }

    return 0;
}